<template>
  <modal
    id="verify-modal"
    ref="modal"
    :title="'فعالسازی ' + item.label"
    :icon="`d-none d-sm-block ${item.icon}`"
    color="primary"
    :show.sync="show"
    :simple="false"
    :loading="loading"
    @next="next"
  >
    <div v-if="state === 'home'" class="text-center">
      <p>
        <span>جهت فعالسازی</span>
        <span>{{ item.label }}</span>
        <span>خود بر روی دکمه ادامه کلیک کنید</span>
      </p>
      <P>
        <span>ما یک کد فعالسازی به</span>
        <b>{{ itemValue }}</b>
        <span>ارسال خواهیم کرد</span>
      </P>
      <p>کد دریافت شده را در مرحله بعد وارد کنید</p>
    </div>
    <form
      v-else
      class="text-center mt-4 mb-3"
      data-vv-scope="form-2"
      @submit.prevent="verify"
    >
      <div class="mx-auto form-inner" style="max-width: 350px">
        <p>
          <span>یک {{ item.tag }} حاوی کد فعالسازی به</span>
          <b>{{ itemValue }}</b>
          <span>ارسال شد</span>
        </p>
        <p>کد دریافت شده را در کادر زیر وارد کنید</p>
        <div class="d-flex mb-3">
          <div class="d-flex align-items-center pl-3">
            <i class="ic-password font-20 text-muted" />
          </div>
          <input
            v-model="code"
            v-validate="'required|numeric|length:4'"
            v-number
            v-focus
            type="tel"
            name="code"
            class="form-control form-control-lg  validate-bg"
            placeholder="کد تایید"
            data-vv-as="کد تایید"
            maxlength="4"
            minlength="4"
          />
        </div>
        <p v-if="timer.text" class="text-muted mb-0">
          <span>ارسال مجدد بعد از</span>
          <span class="d-inline-block" style="width:30px">
            {{ timer.text }}
          </span>
        </p>
        <span v-else class="btn btn-outline-primary btn-sm" @click="sendCode">
          {{ 'ارسال مجدد کد' }}
        </span>
      </div>
    </form>
  </modal>
</template>

<script>
import { mapState } from 'vuex'
export default {
  name: 'LoginPopup',
  props: {
    itemName: { type: String, default: 'mobile' }
  },
  data() {
    return {
      loading: false,
      state: 'home',
      show: false,
      code: '',
      timer: {
        start: 0,
        text: '',
        timeout: null,
        allowed: 4 * 60
      }
    }
  },
  computed: {
    itemValue() {
      return this.user ? this.user[this.itemName] : ''
    },
    item() {
      return (
        {
          email: {
            label: 'ایمیل',
            tag: 'ایمیل',
            icon: 'ic-envelope'
          },
          mobile: {
            label: 'موبایل',
            tag: 'پیامک',
            icon: 'ic-smart-phone'
          }
        }[this.itemName] || {}
      )
    },
    ...mapState({ user: state => state.user.data })
  },
  watch: {
    show(val) {
      if (!val) this.$emit('update:itemName', null)
    },
    itemName(val) {
      if (val) this.show = true
      this.state = 'home'
    },
    state(after) {
      if (after === 'verify') {
        this.timer.start = new Date().getTime()
        this.updateTimer()
      } else {
        this.stopTimer()
      }
    }
  },
  methods: {
    next() {
      if (this.state === 'home') this.sendCode()
      else this.verifyCode()
    },
    sendCode() {
      this.$store
        .dispatch('user/verifyEmailOrMobile', {
          $vm: this,
          _method: 'get',
          _item: this.itemName
        })
        .then(() => {
          this.state = 'verify'
          this.$message.success('کد تایید برای شما ارسال شد')
        })
    },
    verifyCode() {
      this.$store
        .dispatch('user/verifyEmailOrMobile', {
          $vm: this,
          $data: { code: this.code },
          _method: 'put',
          _item: this.itemName
        })
        .then(() => {
          this.state = 'home'
          this.show = false
          this.$store.commit('user/updateData', {
            ...this.user,
            [`${this.itemName}Active`]: true
          })
          this.$message.success(this.item.label + ' باموفقیت تایید شد ')
        })
    },
    updateTimer() {
      window.clearTimeout(this.timer.timeout)
      let elapsed =
        this.timer.allowed -
        Math.floor(new Date().getTime() - this.timer.start) / 1000

      if (elapsed <= 0) return this.stopTimer()

      this.timer.text =
        Math.floor(elapsed / 60) + ':' + Math.floor(elapsed % 60)
      this.timer.timeout = window.setTimeout(this.updateTimer, 1000)
    },
    stopTimer() {
      window.clearTimeout(this.timer.timeout)
      this.timer.text = ''
    }
  }
}
</script>
